#!/usr/bin/env python2
# -*- coding: utf-8 -*-

from psychopy import visual, core, gui, data, event, parallel
import time, datetime, random, os, copy, csv, sys
import numpy as np
import sounddevice as sd
wd = 'C:\Users\SWIENSLAB01\Desktop\AAN3_python\defs'
sys.path.append(wd)
import mn
from AAN3_defs import *
from AAN_instructions import *

# Check for escape
def check4esc():
    ''' Checks for escape.
    If escape is pressed, it terminates the program.
    '''
    keys = event.getKeys(keyList = ['escape'])
    if len(keys)>0 and 'escape' in keys:
        core.quit()
# Add stuff at start of log file
def add_log(f, start, end):
    f = open(f,'r+')
    content = f.read()
    f.seek(0, 0)
    f.write(start.rstrip('\r\n') + '\n' + end.rstrip('\r\n') + '\nfp: ' + 
        str(FP) + '\nValnr: ' + str(valnr) + '\nTask: ' + task +  
        '\n\n' + content)
    f.close()
# Send triggers
def send_triggers(in_trig):
    p_port.setData(in_trig)
    core.wait(0.05)
    p_port.setData(255)
# Random key for debug
def random_key(key):
    '''Randomise a response.
    Keyword arguments:
    key -- 1 or 2, 1 = obj resp, 2 = sub resp
    '''
    obj_key = ['up','down']
    sub_key = ['1','2','3']
    if key == 1:
        resp = random.sample(obj_key,1)
    elif key == 2:
        resp = random.sample(sub_key,1)
    return resp
# Pause def --------------------------------------------------------------------
def paus(pauses,t,block):
    ''' 
    Keyword arguments:
    pauses -- list of trialnumbers where there should be a pauses (list)
    t -- the current trialnumber (int)
    block -- list of blocknumbers, ex (0,0,0,1,1,1,2,2,2) (list)
    pport -- what trigger to send for pause (int)
    '''
    if t in pauses:
        if block[t] != block[len(block)-1]:
            paus_info.setText(pausInfo % (block[t]+1, max(block)+1))
            paus_info.draw()
            win.flip()
            event.waitKeys(keyList=['space'])
            win.flip()
            core.wait(1)
            send_triggers(223)
# Objective response def -------------------------------------------------------
def obj_def(corr,t,debug):
    if debug == 1: obj_resp = random_key(1)[0]
    elif debug == 0: obj_resp = event.waitKeys(keyList=['up','down','escape'])[0]
    correct = None
    if obj_resp == 'escape': core.quit()
    elif corr[t] == obj_resp: correct = 1
    else: correct = 0
    return obj_resp, correct
# Subjective response def ------------------------------------------------------
def sub_def(debug):
    if debug == 1: sub_resp = random_key(2)[0]
    elif debug == 0: sub_resp = event.waitKeys(keyList=['1','2','3','escape'])[0]
    aware = None
    if sub_resp == 'escape': core.quit()
    elif int(sub_resp) == 1: aware = 0
    else: aware = 1
    return sub_resp, aware
# Staircase def -----------------------------------------------------------------
def staircase():
    fileName = os.path.join(fileDir+'\AAN3_cal_'+fps+'.txt')
    dataFile = open(fileName, 'w')
    dataFile.write('fp\ttrial\tstair\tlevel\taware\tcorrect\n')
    conditions=[
        {'label':'h900', 'startVal': -60, 'nUp':1, 'nDown':1, 'minVal' : -200, 'maxVal' : 0, 'stepSizes':[8,8,4,4,2,2,1], 'nReversals':12, 'stepType':'lin'},
        {'label':'m900','startVal': -80, 'nUp':1, 'nDown':1, 'minVal' : -200, 'maxVal' : 0, 'stepSizes':[8,8,4,4,2,2,1], 'nReversals':12, 'stepType':'lin'},
        {'label':'l900', 'startVal': -100, 'nUp':1, 'nDown':1, 'minVal' : -200, 'maxVal' : 0, 'stepSizes':[8,8,4,4,2,2,1], 'nReversals':12, 'stepType':'lin'},
        {'label':'h1400', 'startVal': -60, 'nUp':1, 'nDown':1, 'minVal' : -200, 'maxVal' : 0, 'stepSizes':[8,8,4,4,2,2,1], 'nReversals':12, 'stepType':'lin'},
        {'label':'m1400','startVal': -80, 'nUp':1, 'nDown':1, 'minVal' : -200, 'maxVal' : 0, 'stepSizes':[8,8,4,4,2,2,1], 'nReversals':12, 'stepType':'lin'},
        {'label':'l1400', 'startVal': -100, 'nUp':1, 'nDown':1, 'minVal' : -200, 'maxVal' : 0, 'stepSizes':[8,8,4,4,2,2,1], 'nReversals':12, 'stepType':'lin'}
        ]
    stairs = data.MultiStairHandler(stairType='simple', method = 'random', conditions=conditions, nTrials=10)
    trial = 0
    hit_ready.draw()
    win.flip()
    event.waitKeys('space')
    for level in stairs:
        trial += 1 # count trialnumber
        freq = int(level[1]['label'][1:]) # ex. m900 = 900
        freqLog = level[1]['label']
        db = level[0]
        sound = create_stimulus(condition = 1, frequency = freq, sdur = SDUR, s_lvl = db, fade = FADE, fs = FS)
        fixation.draw()
        win.flip()
        sd.play(sound, FS, mapping = ch[nr_channels])
        core.wait(0.5)
        translate = {900:'down',1400:'up'}
        obj_inst.draw()
        win.flip()
        obj_resp, correct = obj_def([translate[freq]],0,debug)
        sub_inst.draw()
        win.flip()
        subj_resp, aware = sub_def(debug)
        # simulation ======================#
        # if '9' in level[1]['label']:       #
            # if level[0] < -86: aware = 0   #
            # elif level[0] > -86: aware = 1 #
        # elif '14' in level[1]['label']:    #
            # if level[0] < -80: aware = 0   #
            # elif level[0] > -80: aware = 1 #
        #==================================#
        stairs.addResponse(aware)  # this is ESSENTIAL
        #'fp\ttrial\tstair\tlevel\taware\tcorrect\n'
        #  i    i      s      i      i       i
        dataFile.write('%i\t%i\t%s\t%f\t%i\t%i\n'%(FP, trial, freqLog, db, aware, correct))
# Practice def -----------------------------------------------------------------
def validation():
    if task == 'Validation':
        fileName = os.path.join(fileDir+'\AAN3_val_'+fps+'_'+str(valnr)+'.txt')
        dataFile = open(fileName, 'w')
        start_time = 'Experiment start: ' + datetime.datetime.now().strftime("%y-%m-%d %H:%M")
        dataFile.write('fp\ttrial\tcond\tlevel\tsub_resp\tobj_resp\tcorrect\taware\tvalnr\n')
    random.seed()
    
    ntp = 100 # number of trials practice (has to be divisible by 10)
    
    obj_list_L = []
    obj_list_H = []
    sub_list_L = []
    sub_list_H = []
    catch_list = []

    # Create trials for practice/validation
    cond = [1]*9 + [2]*9 + [3]*2
    corr = ['down']*9 + ['up']*9 + ['catch']*2
    level = [sL]*9 + [sH]*9 + [0]*2
    trig = [254]*9 + [253]*9 + [251]*2

    rand_cond = []
    rand_corr = []
    rand_lvl = []
    rand_trig = []

    # makes the trials
    for i in range(int(ntp/20)): #100/20 = 5 loop 5 times with 20 trials per loop and add 9 + 9 + 2 conditions
        order = range(len(cond))
        random.shuffle(order)
        for trial in range(len(cond)):
            rand_cond += [cond[order[trial]]]
            rand_corr += [corr[order[trial]]]
            rand_lvl += [level[order[trial]]]
            rand_trig += [trig[order[trial]]]

    # --------------------------------------------------------------------------
    hit_ready.draw() # press space to start
    win.flip()
    event.waitKeys(keyList=['space'])
    win.flip()
    core.wait(1)
    # 900 Hz tone
    sound1 = create_stimulus(condition = 1, frequency = 900, sdur = SDUR, s_lvl = sL, fade = FADE, fs = FS)
    # 1400 Hz tone
    sound2 = create_stimulus(condition = 1, frequency = 1400, sdur = SDUR, s_lvl = sH, fade = FADE, fs = FS)
    # catch - no sound
    sound3 = create_stimulus(condition = 2, frequency = 1400, sdur = SDUR, s_lvl = -50, fade = FADE, fs = FS)
    sounds = [sound1,sound2,sound3]
    # --------------------------------------------------------------------------
    for t in range(ntp):
        if debug == 0:
            fixation.draw()
            win.flip() # show cross 
            # Play sound -----------------------------------------------------------
            send_triggers(rand_trig[t])
            core.wait(dur1)
            sd.play(sounds[rand_cond[t]-1], FS, mapping = ch[nr_channels])
            core.wait(dur2)
    # --------------------------------------------------------------------------
        check4esc()
    # display instructions
        obj_inst.draw()
        win.flip()
    # get objective response
        obj_resp, obj_corr = obj_def(rand_corr,t,debug)
    # --------------------------------------------------------------------------
    # display instructions
        sub_inst.draw()
        win.flip()
    # get subjective response
        sub_resp, aware = sub_def(debug)
        if rand_cond[t] == 1: # 900 Hz tone
            sub_list_L += [aware] # store aware 0,1
            obj_list_L += [obj_corr] # store correct 0,1
        elif rand_cond[t] == 2: # 1400 Hz tone
            sub_list_H += [aware]
            obj_list_H += [obj_corr]
        elif rand_cond[t] == 3: # Catch
            catch_list += [aware]

        if task == 'Validation': # if validation, make log
            #'fp\ttrial\tcond\tlevel\tsub_resp\tobj_resp\tcorrect\taware\tvalnr\n'
            # i    i      i      f       i         s         i       i
            dataFile.write('%i\t%i\t%i\t%f\t%i\t%s\t%i\t%i\t%i\n'
                %(FP, t+1, rand_cond[t], rand_lvl[t], int(sub_resp), obj_resp, obj_corr, aware, int(valnr)))
    if task == 'Validation': # if validation, store timestamps and close.
        dataFile.close()
        end_time = 'Experiment end: ' + datetime.datetime.now().strftime("%y-%m-%d %H:%M")
        add_log(fileName, start_time, end_time)
    # give some output to user
        aware_L, correct_L, aware_correct_L, unaware_correct_L = calc(obj_list_L,sub_list_L)
        aware_H, correct_H, aware_correct_H, unaware_correct_H = calc(obj_list_H,sub_list_H)
        aware_catch = calc_aware(catch_list)
        print('A900: %.1f\nA1400: %.1f\nC900: %.1f\nC1400: %.1f\nAC900: %.1f\nAC1400: %.1f\nUC900: %.1f\nUC1400: %.1f\nAcatch: %.1f\n' % (aware_L * 100, aware_H * 100, correct_L * 100, correct_H * 100, aware_correct_L * 100, aware_correct_H * 100, unaware_correct_L * 100, unaware_correct_H * 100, aware_catch * 100))
# Experiment def ---------------------------------------------------------------
def experiment():
    '''
    Conditions:
    1 = critical 900Hz (calibrated dB)
    2 = critical 1400Hz (calibrated dB)
    3 = catch (~0 dB)
    '''
    fileName = os.path.join(fileDir+'\AAN3_fp'+fps+'.txt')
    dataFile = open(fileName, 'w')
    start_time = 'Experiment start: ' + datetime.datetime.now().strftime("%y-%m-%d %H:%M")
    dataFile.write('fp\ttrial\tblock\tcond\tlevel\tsubj_resp\tobj_resp\taware\tcorrect\ttrigger\n')

    random.seed()
    obj_list_L = []
    obj_list_H = []
    sub_list_L = []
    sub_list_H = []
    catch_list = []
    nte = 800 # number of trials experiment
    nbl = 8 # number of blocks
    # Blocks and breaks 800 / 8 = 100
    block = []
    pauses = []
    for i in range(nbl):
        pauses += [[]]
        pauses[i] = int(nte/nbl * i + (nte/nbl - 1))
        block += [i] * int(nte/nbl)

    # Create trials for experiment
    cond = [1]*9 + [2]*9 + [3]*2
    corr = ['down']*9 + ['up']*9 + ['catch']*2 
    level = [sL]*9 + [sH]*9 + [0]*2
    trig = [254]*9 + [253]*9 + [251]*2

    rand_cond = []
    rand_corr = []
    rand_lvl = []
    rand_trig = []

    # makes the trials 20 trials per interation. 40 * 20 = 800
    for i in range(40):
        order = random.sample(range(len(cond)),len(cond))
        for trial in range(len(cond)):
            rand_cond += [cond[order[trial]]]
            rand_corr += [corr[order[trial]]]
            rand_lvl += [level[order[trial]]]
            rand_trig += [trig[order[trial]]]
    
    #---------------------------------------------------------------------------
    # WARM UP SYSTEM WARM UP SYSTEM WARM UP SYSTEM WARM UP SYSTEM WARM UP SYSTEM
    sound = create_stimulus(condition = 2, sdur = 0.1, s_lvl = -200, fade = FADE, fs = FS)
    sd.play(sound, FS, mapping = ch[nr_channels])
    time.sleep(0.5)
    # 900 Hz tone
    sound1 = create_stimulus(condition = 1, frequency = 900, sdur = SDUR, s_lvl = sL, fade = FADE, fs = FS)
    # 1400 Hz tone
    sound2 = create_stimulus(condition = 1, frequency = 1400, sdur = SDUR, s_lvl = sH, fade = FADE, fs = FS)
    # catch - no sound
    sound3 = create_stimulus(condition = 2, frequency = 1400, sdur = SDUR, s_lvl = -50, fade = FADE, fs = FS)
    sounds = [sound1,sound2,sound3]
    #---------------------------------------------------------------------------
    exp_instruction.draw()
    win.flip()
    event.waitKeys(keyList=['space'])
    win.flip()
    core.wait(1)
    send_triggers(223) # start block
    for t in range(len(rand_cond)):
        fixation.draw()
        win.flip() # show cross
        #-----------------------------------------------------------------------
        #if debug == 0:
        send_triggers(rand_trig[t])
        core.wait(dur1)
        sd.play(sounds[rand_cond[t]-1], FS, mapping = ch[nr_channels])
        core.wait(dur2)
        #-----------------------------------------------------------------------
        check4esc()
# display instructions and wait
        obj_inst.draw()
        win.flip()
# get objective response
        obj_resp, obj_corr = obj_def(rand_corr,t,debug)
# display instructions and wait
        sub_inst.draw()
        win.flip()
# get subjective response
        sub_resp, aware = sub_def(debug)      
        # store correct and aware
        if rand_cond[t] == 1: # critical trials
            sub_list_L += [aware] # store aware 0,1
            obj_list_L += [obj_corr] # store correct 0,1
        elif rand_cond[t] == 2: # critical trials
            sub_list_H += [aware] # store aware 0,1
            obj_list_H += [obj_corr] # store correct 0,1
        elif rand_cond[t] == 3: # catch trials
            catch_list += [aware]
        #fp\ttrial\tblock\tcond\tlevel\tsubj_resp\tobj_resp\taware\tcorrect\ttrigger\n
        #i    i       i     i      f        i         s        i       i        i
        dataFile.write('%i\t%i\t%i\t%i\t%f\t%i\t%s\t%i\t%i\t%i\n'
            % (FP,t+1,block[t]+1,rand_cond[t], rand_lvl[t], 
            int(sub_resp),obj_resp, aware, obj_corr, rand_trig[t]))
        paus(pauses,t,block)
    dataFile.close()
    end_time = 'Experiment end: ' + datetime.datetime.now().strftime("%y-%m-%d %H:%M")
    add_log(fileName, start_time, end_time)
    # give some output to user
    aware_L, correct_L, aware_correct_L, unaware_correct_L = calc(obj_list_L,sub_list_L)
    aware_H, correct_H, aware_correct_H, unaware_correct_H = calc(obj_list_H,sub_list_H)
    aware_catch = calc_aware(catch_list)
    print('Aware 900: %.1f\nAware 1400: %.1f\nCorrect 900: %.1f\nCorrect 1400: %.1f\nAware correct 900: %.1f\nAware correct 1400: %.1f\nUnaware correct 900: %.1f\nUnaware correct 1400: %.1f\nAware catch: %.1f\n' % (aware_L * 100, aware_H * 100, correct_L * 100, correct_H * 100, aware_correct_L * 100, aware_correct_H * 100, unaware_correct_L * 100, unaware_correct_H * 100, aware_catch * 100))

# check if there is a memory file
#memory_data = []
if os.path.isfile('AAN3_mem.txt'):
    print('Found memory!')
    with open('AAN3_mem.txt', 'r') as memory:
        memory_data = [data.split(',') for data in memory][0]
    expInfo = gui.Dlg(title="Auditory detection")
    expInfo.addField('Subject', memory_data[0])
    expInfo.addField('Valnr', memory_data[1])
    expInfo.addText('Experiment Info')
    expInfo.addField('Task', choices = ['Validation','Practice','Staircase','Experiment'])
    expInfo.addField('Level 900Hz', float(memory_data[3]))
    expInfo.addField('Level 1400Hz', float(memory_data[4]))
    ok_data = expInfo.show() # show dialog and wait for OK or Cancel
    if expInfo.OK:  # or if ok_data is not None
        if ok_data[3] > 0 or ok_data[4] > 0:
            print('Too high level!')
            core.quit()
        print('Subject: %i\nTask: %s\nLevel 900Hz: %f\nLevel 1400Hz: %f\n' %(int(ok_data[0]), ok_data[2], ok_data[3], ok_data[4]))
    else:
        print('user cancelled')
        core.quit()
else:
    print('No memory, making.')
    # present a dialogue to give subject nr and select program
    expInfo = gui.Dlg(title="Auditory detection")
    expInfo.addField('Subject', '01')
    expInfo.addField('Valnr', '01')
    expInfo.addText('Experiment Info')
    expInfo.addField('Task', choices = ['Validation','Practice','Staircase','Experiment'])
    expInfo.addField('Level 900Hz', -40)
    expInfo.addField('Level 1400Hz', -40)
    ok_data = expInfo.show()  # show dialog and wait for OK or Cancel
    if expInfo.OK:  # or if ok_data is not None
        if ok_data[3] > 0 or ok_data[4] > 0:
            print('Too high level!')
            core.quit()
        print('Subject: %i\nTask: %s\nLevel 900Hz: %f\nLevel 1400Hz: %f\n' %(int(ok_data[0]), ok_data[2], ok_data[3], ok_data[4]))
    else:
        print('user cancelled')
        core.quit()
#
sd.default.device = "ASIO Fireface USB"
print 'Sound device ------------------------------------------------------------'
print sd.default.device

# Parallel port
# p_port = parallel.ParallelPort(address = "0x4020") # room 225
p_port = parallel.ParallelPort(address='0x3028') # room 223
#
# Global variables
fileDir = 'C:\Users\SWIENSLAB01\Desktop\AAN3_python\logs'
#fileDir = 'C:\Users\RAEK2031\Box Sync\AAN3\Python_scripts\logs'
FADE = 0.005
FS = 48000
SDUR = 0.1
ch = [[1,2],[3,4,1,2]]
nr_channels = 1 # 0 = 2, 1 = 4

dur1 = 0.10 #0.09
dur2 = 0.585 #0.585
debug = 0

# from prompt
fps = ok_data[0]
FP = int(ok_data[0])
valnr = ok_data[1]
task = ok_data[2]
sL = ok_data[3]
sH = ok_data[4]

with open('AAN3_mem.txt', 'w') as memory:
    memory.write(','.join(str(data) for data in [fps, valnr, task, str(sL),str(sH)]))
#
# Objects
#Screen 1920, 1080
win = visual.Window([1920, 1080], allowGUI = False, fullscr = False, #1920, 1080
    monitor = 'testMonitor', units = 'height')
#Stimuli
fixation = visual.TextStim(win, color='black', height = 0.03, text = '+')
sub_inst = visual.TextStim(win, color='black', height = 0.02, text = subInst) 
obj_inst = visual.TextStim(win, color='black', height = 0.02, text = objInst)
hit_ready = visual.TextStim(win, color='black', height = 0.02,text = spaceInfo)
exp_instruction = visual.TextStim(win, color='black', height = 0.02, text = instructionInfo) 
paus_info = visual.TextStim(win, color='black', height = 0.02,text = '')
end = visual.TextStim(win, color='black', height = 0.02, text = endInfo % task)

#==============================================================================#
# Procedure
if task == 'Experiment':
    experiment()
if task == 'Staircase':
    staircase()
if task == 'Validation':
    validation()
if task == 'Practice':
    validation()

end.draw()
win.flip()
event.waitKeys()

win.close()
core.quit()